/*********************************************************************
*                                                                    *          
*                              FLY                                   *
*                           --E#Y#E--				                 *
*                         ===MUSCLE===                               *
*                                                                    *
*********************************************************************/
/* Header Files */
#include "win.h"

/* Screen */
#define WIDTH 800
#define HEIGHT 600

/*---------------------------------------------------------------------------*/

static unsigned int width;
static unsigned int height;
static Display                 *display;
static Window                  monitor;
static int depth;

GLint                   att[] = { GLX_USE_GL,
				  GLX_RGBA,
				  GLX_RED_SIZE, 4,
				  GLX_GREEN_SIZE, 4,
				  GLX_BLUE_SIZE, 4,
				  GLX_ALPHA_SIZE, 4,
				  GLX_AUX_BUFFERS,  0,
				  GLX_ACCUM_RED_SIZE, 0,
				  GLX_ACCUM_GREEN_SIZE, 0,
				  GLX_ACCUM_BLUE_SIZE, 0, 
				  GLX_ACCUM_ALPHA_SIZE, 0,
				  GLX_BUFFER_SIZE, 24,
				  GLX_DEPTH_SIZE, 24,
				  GLX_STENCIL_SIZE, 8,
				  GLX_DOUBLEBUFFER, None};
XVisualInfo             *vi;
Colormap                cmap;
XSetWindowAttributes    swa;
Window                  windows;
GLXContext              glc;
XWindowAttributes       gwa;
XEvent                  xev;

/*-------------------------------------------------------------------------*/

/* Create Window */
void createWin()
{	
	/*const char *sname = "[ LANDSCAPE - 0.4 ]";*/
	/*const char *nicon = "[ LANDSCAPE ]";*/
	
	if((display = XOpenDisplay(NULL)) == NULL) 
	{
		printf("\nCannot connect to x server\n\n");
		exit(0);
	}

	monitor = XDefaultRootWindow(display);
 
	if((vi = glXChooseVisual(display, 0, att)) == NULL) 
	{
		printf("\nNo matching visual\n\n");
		exit(0);
	}
      
    	depth = XDefaultDepth(display, monitor);  
        
	if((cmap = XCreateColormap(display, monitor, vi->visual, AllocNone)) == 0) 
	{
		printf("\nCannot create colormap\n\n");
		exit(0);
	}
	
	width = WIDTH;
	height = HEIGHT;
	
	//width = XDisplayWidth(display, 0);
	//height = XDisplayHeight(display, 0);
	
	//XResizeWindow(display, windows, width, height);

	/*static XSizeHints sizeh;
	sizeh.flags = PSize | PMinSize | PMaxSize;
	sizeh.min_width = width;
	sizeh.max_width = width;
	sizeh.min_height = height;
	sizeh.max_height = height;*/

	cmap = XCreateColormap(display, monitor, vi->visual, AllocNone);
	
	swa.colormap = cmap;
	swa.event_mask = ExposureMask | KeyPressMask | KeyReleaseMask | 
					ButtonPressMask | StructureNotifyMask;
	
	windows = XCreateWindow(display,monitor,0,0,width,height,2, 
				vi->depth, InputOutput, vi->visual,
				CWBorderPixel | CWColormap | CWEventMask | 
				CWOverrideRedirect, &swa);
				
	/*XSetStandardProperties(display,windows,sname,nicon,None,0,0,&sizeh);*/
	
	XStoreName(display, windows, "[ LANDSCAPE - 0.4 ]");
	XMapWindow(display, windows);
	
	glc = glXCreateContext(display, vi, NULL , GL_TRUE);
	glXMakeCurrent(display, windows, glc); 
	glEnable(GL_DEPTH_TEST);  
}

/*-------------------------------------------------------------------------*/

/* Close Window */
void closeWin()
{
	glXMakeCurrent(display, None, NULL);
	glXDestroyContext(display, glc);
	XDestroyWindow(display, windows);
	XCloseDisplay(display);
	exit(0);
}

/*-------------------------------------------------------------------------*/

/* Look / View */
void perspective() 
{	
	XGetWindowAttributes(display, windows, &gwa);
	
	/* Viewport*/
	glViewport(0, 0, gwa.width, gwa.height);

	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();

	/* Perspective */
	gluPerspective(52.0f, (float)(gwa.width) 
	/ (float)(gwa.height), 1.0f, 100.0f);

	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	
	glXSwapBuffers(display, windows);
	
	/* Screen Resolution */
	printf("%dx%d screen ", gwa.width, gwa.height);
}

/*-------------------------------------------------------------------------*/

/* Event Loop */
void eventloop(void) 
{
	int events;
	XFlush(display);
	events = XPending(display);
	while (( events != 0)) 
	{
		events--;
		XNextEvent(display, &xev);
		process_event(xev);
	}
}

/*---------------------------------------------------------------------------*/

